﻿using Kivii.DataAnnotations;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Kivii.Lims.Entities
{
    [Alias(Configs.TableNameTest)]
    [Api(Description = "检验信息")]
    public class Test : EntityWithMetadata, IEntityInAssemblyDb, IEntityHasCreator,IEntityHasRemark,IEntityHasRole
    {
        /// <summary>
        /// 聚合同一项目下的所有检测记录
        /// </summary>
        [ApiMember(Description = "RootKvid")]
        [DefaultEmptyGuid]
        [IgnoreUpdate]
        public Guid RootKvid { get; set; }

        #region 关联信息 
        [ApiMember(Description = "样品Kvid")]
        [DefaultEmptyGuid]
        [IgnoreUpdate]
        public Guid SampleKvid { get; set; }

        [ApiMember(Description = "样品根Kvid")]
        [DefaultEmptyGuid]
        public Guid SampleRootKvid { get; set; }


        [ApiMember(Description ="关联方法标准Kvid")]
        [Required]
        public Guid StandardKvid { get; set; }

        [ApiMember(Description = "关联方法标准的检验项目Kvid")]
        [Required]
        public Guid DetectionKvid { get; set; }
        #endregion

        [ApiMember(Description = "实测值")]
        [StringLength(500)]
        public string Value { get; set; }

        [ApiMember(Description = "原始记录路径")]
        [StringLength(200),Default("")]
        public string OriginalFilePath { get; set; }

        #region 人员相关
        [ApiMember(Description = "创建人Kvid ")]
        [IgnoreUpdate]
        [CurrentMemberKvid]
        public Guid CreatorKvid { get; set; }

        [ApiMember(Description = "创建人")]
        [IgnoreUpdate]
        [StringLength(50), CurrentMemberName]
        public string CreatorName { get; set; }

        [ApiMember(Description = "审核人员Kvid")]
        [DefaultEmptyGuid]
        public Guid ReviewerKvid { get; set; }

        [ApiMember(Description = "审核人员")]
        [StringLength(50), Default("")]
        public string ReviewerName { get; set; }

        #endregion
        [ApiMember(Description = "备注信息")]
        [StringLength(200),Default("")]
        public string Remark { get; set; }

        #region 时间相关
        [ApiMember(Description = "审核时间")]
        public DateTime? ReviewTime { get; set; }
        #endregion
    }

}
